/**
 * <copyright>
 *   IBM WebSphere Application Developer
 *   (C) Copyright IBM Corp. 2001
 * </copyright>
 */
package com.ibm.etools.xmlschema.beans;

import org.w3c.dom.*;

class NodeStringTokenizer 
{
  private String buffer;
  private int length;
  private int offset = 0; // current index
  
  private NodeStringTokenizer()
  {
  }
  
  public NodeStringTokenizer(String value)
  {
  	if (value == null)
  	  buffer = "";
  	else
      buffer = value;
    length = buffer.length();
  }
  
  public boolean hasNextToken()
  {
  	if (offset >= length)
  	  return false;
  	else
      return true;
  }
  
  public NodeString nextToken()
  {
  	int i = nextCDATASection();
  	if (i == -1)
  	{  	  
  	  NodeString ns = new NodeString(Node.TEXT_NODE,buffer.substring(offset,length));
      offset = length;
      return ns;
  	}
  	else if (i == offset)
  	{
  	  return new NodeString(Node.CDATA_SECTION_NODE,getCDATASectionContent());
  	}
  	else
  	{
      NodeString ns = new NodeString(Node.TEXT_NODE,buffer.substring(offset,i));
      offset = i;
      return ns;
  	}
  }
  
  private int nextCDATASection()
  {
    int j;
    if ((j=buffer.indexOf("<![CDATA[",offset)) != -1
        && buffer.indexOf("]]>",j) != -1)
      return j;
    else
      return -1;
  }
  
  private String getCDATASectionContent()
  {
  	int start = offset;
  	int end = length;
  	
  	start = buffer.indexOf("<![CDATA[",offset); // start == offset
  	end = buffer.indexOf("]]>",start); 
  	offset = end + 3; 
    return buffer.substring(start+9,end);
  }
}
